digits(6); %Define the number of used strings

zahl1 = 10000.0; %Define the numbers to be added 
zahl2 = 3.14159;
zahl3 = 2.71828;

a = vpa(zahl1); % Define floating numbers to be added and round them to the predefined number of digits
b = vpa(zahl2);
c = vpa(zahl3);

sum_exact = zahl1 + zahl2 + zahl3;
E = [' The exact value is ', num2str(sum_exact)];
disp(E)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% With Kahan-Algorithm

v = [a;b;c]; % Write floating numbers in a vector 

sum_kahan = 0; %Initialize sum
e = 0; %Initialize error
n = size(v,1);%Define variable n as length of the vector 

for i = 1:n
    y = v(i,1) - e;
    temp = sum_kahan + y;
    e = (temp-sum_kahan) - y;
    sum_kahan = temp;
end

sum_kahan_x = char(sum_kahan); %Convert type from sym to string for printing
Z = [' The sum computed WITH Kahan algorithm is ', sum_kahan_x];
disp(Z)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Without Kahan-Algorithm

sum_without = 0;

for i = 1:n
    temp_without = sum_without + v(i,1);
    sum_without = temp_without;
end

sum_without_x = char(sum_without);
W = [' The sum computed withOUT Kahan algorithm is ', sum_without_x];
disp(W)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Error calculation

%convert the limited digit to back to double

sum_without_double = double(sum_without);
sum_kahan_double = double(sum_kahan);

e_abs_without = abs(sum_without_double - sum_exact); 
e_abs_with = abs(sum_kahan_double - sum_exact);

F = [' The absolute error withOUT Kahan algorithm is ', num2str(e_abs_without)];
G = [' The absolute error WITH Kahan algorithm is ', num2str(e_abs_with)];
disp(F)
disp(G)
